import { GraphQLResult } from 'graphql';
import { Observable, Observer, Subscription } from './observable';
import { SelectionSetWithRoot } from './store';
import { QueryManager, WatchQueryOptions } from '../QueryManager';
export declare type QueryObserver = Observer<GraphQLResult>;
export default class ObservableQuery implements Observable<GraphQLResult> {
    queryManager: QueryManager;
    queryId: string;
    selectionSetWithRoot: SelectionSetWithRoot;
    options: WatchQueryOptions;
    isLoading: boolean;
    lastResult: GraphQLResult;
    private observers;
    constructor(queryManager: QueryManager, queryId: string, options: WatchQueryOptions);
    subscribe(observer: QueryObserver): Subscription;
    result(): Promise<GraphQLResult>;
    refetch(): void;
    didReceiveResult(result: GraphQLResult): void;
    didReceiveError(error: Error): void;
}
